searchNodes=[{"type":"module","title":"EctoKsuid","doc":"Custom Ecto type to support ksuids","ref":"EctoKsuid.html"},{"type":"function","title":"EctoKsuid.column/0","doc":"Returns the primitive migration type for an EctoKsuid. This can be used in your migrations, so you don't have to rememeber exactly how large a ksuid is. Examples In an ecto migration: def change ( ) do create table ( :table_name , primary_key : false ) do add ( :id , EctoKsuid . column ( ) , primary_key : true ) end end In your repo config config :my_app , MyApp.Repo , migration_primary_key : [ name : :id , type : :&quot;char(27)&quot; ] , migration_foreign_key : [ name : :id , type : :&quot;char(27)&quot; ]","ref":"EctoKsuid.html#column/0"},{"type":"function","title":"EctoKsuid.generate/0","doc":"Generates a new ksuid. This function returns a 20 byte Ksuid which has 4 bytes as timestamp and 16 bytes of crypto string bytes. This function delegates to the Ksuid library and is functionally similar to Ecto.UUID.generate/0 Examples iex&gt; EctoKsuid . generate ( ) &quot;2mepXBjQq2rZCfwuX68tO53L4uc&quot;","ref":"EctoKsuid.html#generate/0"},{"type":"function","title":"EctoKsuid.remove_prefix/1","doc":"","ref":"EctoKsuid.html#remove_prefix/1"},{"type":"function","title":"EctoKsuid.remove_prefix/2","doc":"Removes the configured prefix from an EctoKsuid. This can be used to get the raw ksuid without the runtime prefix. Examples iex&gt; EctoKsuid . remove_prefix ( &quot;prefix_2EXLuF3dU8v4L4JLInQXNWpjKE0&quot; , % EctoKsuid.Options { prefix : &quot;prefix_&quot; } ) &quot;2EXLuF3dU8v4L4JLInQXNWpjKE0&quot; iex&gt; EctoKsuid . remove_prefix ( &quot;2EXLuF3dU8v4L4JLInQXNWpjKE0&quot; , % EctoKsuid.Options { prefix : &quot;&quot; } ) &quot;2EXLuF3dU8v4L4JLInQXNWpjKE0&quot;","ref":"EctoKsuid.html#remove_prefix/2"},{"type":"type","title":"EctoKsuid.database_ksuid/0","doc":"A database_ksuid is the value of the EctoKsuid in the database. It contains just the ksuid without the configured prefix.","ref":"EctoKsuid.html#t:database_ksuid/0"},{"type":"type","title":"EctoKsuid.runtime_ksuid/0","doc":"A runtime_ksuid is the value of the EctoKsuid in the elixir application. It contains the configured prefix and the ksuid stored in the database.","ref":"EctoKsuid.html#t:runtime_ksuid/0"},{"type":"type","title":"EctoKsuid.t/0","doc":"An EctoKsuid is a base62 encoded string. That may or may not include an optional configure prefix.","ref":"EctoKsuid.html#t:t/0"},{"type":"module","title":"EctoKsuid.Options","doc":"Struct containing validated options This is used internally to generate the options used by the callbacks of the Ecto.ParameterizedType behaviour.","ref":"EctoKsuid.Options.html"},{"type":"function","title":"EctoKsuid.Options.compile/1","doc":"Compiles EctoKsuid.Options given a keyword list of opts","ref":"EctoKsuid.Options.html#compile/1"},{"type":"function","title":"EctoKsuid.Options.default/0","doc":"Returns the default options for EctoKsuid","ref":"EctoKsuid.Options.html#default/0"},{"type":"function","title":"EctoKsuid.Options.prefix/1","doc":"Returns the prefix for a given set of options","ref":"EctoKsuid.Options.html#prefix/1"},{"type":"type","title":"EctoKsuid.Options.t/0","doc":"","ref":"EctoKsuid.Options.html#t:t/0"},{"type":"module","title":"EctoKsuid.Type","doc":"Contains callbacks for an Ecto.ParameterizedType","ref":"EctoKsuid.Type.html"},{"type":"function","title":"EctoKsuid.Type.autogenerate/1","doc":"","ref":"EctoKsuid.Type.html#autogenerate/1"},{"type":"function","title":"EctoKsuid.Type.cast/2","doc":"","ref":"EctoKsuid.Type.html#cast/2"},{"type":"function","title":"EctoKsuid.Type.dump/3","doc":"","ref":"EctoKsuid.Type.html#dump/3"},{"type":"function","title":"EctoKsuid.Type.init/1","doc":"","ref":"EctoKsuid.Type.html#init/1"},{"type":"function","title":"EctoKsuid.Type.load/3","doc":"","ref":"EctoKsuid.Type.html#load/3"},{"type":"function","title":"EctoKsuid.Type.type/1","doc":"","ref":"EctoKsuid.Type.html#type/1"},{"type":"module","title":"EctoKsuid.Validator","doc":"Validates if a given value is a valid EctoKsuid","ref":"EctoKsuid.Validator.html"},{"type":"function","title":"EctoKsuid.Validator.is_valid?/1","doc":"Validates a given ksuid. Will check that the value: has the correct length only includes the base62 alphabet Examples iex&gt; EctoKsuid.Validator . is_valid? ( &quot;2mepXCkbpLkY0hrFkORS5khkcGT&quot; ) { :ok , valid_ksuid } iex&gt; EctoKsuid.Validator . is_valid? ( nil ) :error","ref":"EctoKsuid.Validator.html#is_valid?/1"},{"type":"function","title":"EctoKsuid.Validator.is_valid?/2","doc":"Validates a given EctoKsuid. Will check that the value: has the configured prefix has the correct length only includes the base62 alphabet Examples iex&gt; EctoKsuid.Validator . is_valid? ( &quot;2mepXDSdV0JSCqrGCJPX2WsBGDj&quot; , % EctoKsuid.Options { prefix : &quot;&quot; } ) { :ok , valid_ksuid } iex&gt; EctoKsuid.Validator . is_valid? ( &quot;prefix_2mepXCGBse2JRbrM3BeX4NEL93b&quot; , % EctoKsuid.Options { prefix : &quot;prefix_&quot; } ) { :ok , valid_ksuid } iex&gt; EctoKsuid.Validator . is_valid? ( nil , % EctoKsuid.Options { prefix : &quot;&quot; } ) :error iex&gt; EctoKsuid.Validator . is_valid? ( &quot;wrong_2mepXD9zNNZKG4CA8OKjhdZAgmL&quot; , % EctoKsuid.Options { prefix : &quot;prefix_&quot; } ) :error","ref":"EctoKsuid.Validator.html#is_valid?/2"},{"type":"extras","title":"ecto_ksuid","doc":"EctoKsuid allows seamless usage of ksuids with :ecto in your application. To get a better idea of what ksuids are, and how they came to be I highly recommend reading A breif History of the UUID [Ksuid] borrows core ideas from the ubiquitous UUID standard, adding time-based ordering and more friendly representation formats. Additionally, EctoKsuid allows easy addition of a :prefix to the ksuid that are available at runtime. This generates developer friendly ids much like stripe's object prefixed ids in your elixir application. Example Ksuids using the &quot;user_&quot; prefix &quot;user_2EgT2R97RRNXWXdA3Ov6znVLDCd&quot; &quot;user_2EgT5YAJ1EMj86IdI8In8Cmfsnj&quot; &quot;user_2EgT6WuSzOmcF9bZaRdS3X6lEaL&quot; &quot;user_2EgT7SEl7LaIGIHIQ1gIjB9eVwT&quot; &quot;user_2EgT8B20KvdsIQznKX6Tuh2RGDe&quot;","ref":"readme.html"},{"type":"extras","title":"ecto_ksuid - Documentation","doc":"Documentation can be found online on HexDocs .","ref":"readme.html#documentation"},{"type":"extras","title":"ecto_ksuid - Installation","doc":"Add :ecto_ksuid to your list of dependencies in mix.exs def deps do [ # ... { :ecto_ksuid , &quot;~&gt; 0.3.0&quot; } ] end Install using mix. mix deps.get","ref":"readme.html#installation"},{"type":"extras","title":"ecto_ksuid - Basic Usage","doc":"EctoKsuid is just a custom Ecto.ParameterizedType and can be used in your application just like any other Ecto type. Add columns to your database defmodule MyApp.Repo.Migrations.AddPublicIdToUsers do use Ecto.Migration def change do alter table ( :users ) do add :public_id , EctoKsuid . column ( ) end end end Add fields to your schema defmodule MyApp.User do use Ecto.Schema schema &quot;users&quot; do # ... field :public_id , EctoKsuid end end","ref":"readme.html#basic-usage"},{"type":"extras","title":"ecto_ksuid - Guides","doc":"For more details on how to use this library, check out the guides: Using Ksuid as the Default Configuring Prefix","ref":"readme.html#guides"},{"type":"extras","title":"Using Ksuid as the Default","doc":"If you are starting a new project with ecto, it may be desirable to use ksuids as the default in your system. This guide will guide you through the steps needed.","ref":"using_ksuid_as_default.html"},{"type":"extras","title":"Using Ksuid as the Default - Configuring Migrations","doc":"This is very similar to configuring your migrations to use a :binary_id as a default. See also the Repo Configuration section of Ecto.Migration . Configure your Repo. # config/config.exs config :my_app , MyApp.Repo , migration_primary_key : [ type : :&quot;char(27)&quot; ] , migration_foreign_key : [ type : :&quot;char(27)&quot; ] Create migrations as you normally would. # priv/repo/migrations/create_posts.exs defmodule MyApp.Repo.Migrations.CreatePosts do use Ecto.Migration def change ( ) do create table ( :posts ) do add :title , :string end create table ( :comments ) do add :post_id , references ( :posts ) end end end Now, any migrations that will add a :primary_key of :id with the EctoKsuid type. Additionally, any references will use the EctoKsuid type.","ref":"using_ksuid_as_default.html#configuring-migrations"},{"type":"extras","title":"Using Ksuid as the Default - Configuring Schemas","doc":"This is very similar to configuring your application to use a :binary_id as default. See also the Schema Attributes section of Ecto.Schema . Define a module to be use as a base # lib/my_app/schema.ex defmodule MyApp.Schema do defmacro __using__ ( _ ) do quote do use Ecto.Schema @primary_key { :id , EctoKsuid , autogenerate : true } @foreign_key_type EctoKsuid end end end Now use MyApp.Schema instead of Ecto.Schema to define new schemas in your application. # lib/my_app/comment.ex defmodule MyApp.Comment do use MyApp.Schema schema &quot;comments&quot; do belongs_to :post , MyApp.Post end end Now any schemas using MyApp.Schema will get the :id field with the type of EctoKsuid as the primary key. The belongs_to association on MyApp.Comment will also define a :post_id field with the EctoKsuid type that references the :id field of the MyApp.Post","ref":"using_ksuid_as_default.html#configuring-schemas"},{"type":"extras","title":"Configuring a Ksuid Prefix","doc":"It may be desirable to add a prefix to your IDs in your application's runtime. This makes logging and debugging a little more developer friendly. This is similar to stripe's object prefixed ids: &quot;user_2EgT2R97RRNXWXdA3Ov6znVLDCd&quot;","ref":"configuring_prefix.html"},{"type":"extras","title":"Configuring a Ksuid Prefix - Allowed Values","doc":"You can use any string you want as the prefix, and it will be injected at runtime. Only the ksuid is stored in the database columns. Some valid values: &quot;ch_&quot; &quot;posts-&quot; &quot;123&quot; &quot;long string because it really doesn't matter, but you really shouldn't&quot; &quot;🐸&quot; Yes, if you like frog or have a frog table, you can use frog emojis as a prefix.","ref":"configuring_prefix.html#allowed-values"},{"type":"extras","title":"Configuring a Ksuid Prefix - Examples:","doc":"Configuring a module attribute # lib/my_app/user.ex defmodule MyApp.User do use Ecto.Schema @primary_key { :id , EctoKsuid , autogenerate : true , prefix : &quot;user_&quot; } schema &quot;users&quot; do # ... end end Configuring a schema field # lib/my_app/post.ex defmodule MyApp.Post do use Ecto.Schema schema &quot;posts&quot; do # ... field :public_id , EctoKsuid , prefix : &quot;post_&quot; end end Configuring with a base schema module defmodule MyApp.Schema do defmacro __using__ ( opts \\\\ [ ] ) do options = Keyword . merge ( opts , autogenerate : true ) quote do use Ecto.Schema @primary_key { :id , EctoKsuid , unquote ( options ) } @foreign_key_type EctoKsuid end end end defmodule MyApp.User do use MyApp.Schema , prefix : &quot;user_&quot; schema &quot;users&quot; do # ... end end","ref":"configuring_prefix.html#examples"},{"type":"extras","title":"Configuring a Ksuid Prefix - Storing the Prefix","doc":"It may be desirable to store the configured prefix in the database. By passing dump_prefix: true , the prefix will be included in the stored column. Note that the column in the database needs to have an appropraite length to store the prefix. If using the default suggestion of a char(27) column, you won't be able to store a prefix without changing the column type. Warning If you decide to change the prefix , all existing rows with the old dumped prefix will need to be migrated to the new prefix. Example Here the &quot;acct_&quot; prefix will be saved in the id column of the accounts table. # lib/my_app/account.ex defmodule MyApp.Account do use Ecto.Schema @primary_key { :id , EctoKsuid , autogenerate : true , prefix : &quot;acct_&quot; , dump_prefix : true } schema &quot;accounts&quot; do # ... end end","ref":"configuring_prefix.html#storing-the-prefix"}]